﻿Imports System.Collections.ObjectModel

Imports MindFusion.Charting
Imports MindFusion.Charting.WinForms
Imports MindFusion.Charting.Components
Imports MindFusion.Drawing

Imports Color = System.Drawing.Color

Public Class MainForm

	Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		' create sample data
		Dim series = New ObservableCollection(Of Series)()
		For i As Integer = 0 To 3
			If i = 0 Then
				series.Add(New BarSeries(New Double() {20, 60, 40, 55}, New String() {"Acer", "Biostar", "Foxconn", "Supermicro"}, New String() {"", "", "", ""}))
			End If
			If i = 1 Then
				series.Add(New BarSeries(New Double() {30, 70, 65, 19}, New String() {"Biostar", "Intel", "Nvidia", "VIA Technologies"}, New String() {"", "", "", ""}))
			End If
			If i = 2 Then
				series.Add(New BarSeries(New Double() {22, 44, 33, 66}, New String() {"Foxconn", "Nvidia", "Marvell", "NexGen"}, New String() {"", "", "", ""}))
			End If
			If i = 3 Then
				series.Add(New BarSeries(New Double() {12, 45, 77, 90}, New String() {"Supermicro", "VIA Technologies", "NexGen", "Toshiba"}, New String() {"", "", "", ""}))
			End If
		Next

		' create labels data
		Dim annotations = New ObservableCollection(Of Series)()
		annotations.Add(New BarSeries(New Double() {0, 0, 0, 0}, New String() {"", "", "", ""}, New String() {"", "", "", ""}, New String() {"Motherboards", "Chipsets", "CPU", "HDD"}))


		Dim mainGrid = New GridPanel()
		mainGrid.HorizontalAlignment = LayoutAlignment.Stretch
		mainGrid.VerticalAlignment = LayoutAlignment.Stretch
		mainGrid.Columns.Add(New GridColumn())
		mainGrid.Rows.Add(New GridRow())
		barChart.RootPanel.Children.Add(mainGrid)

		' add plot
		Dim plot1 = New Plot2D()
		plot1.GridColumn = 1
		plot1.GridRow = 0
		plot1.VerticalScroll = False
		plot1.XAxis = New Axis()
		plot1.YAxis = New Axis() With {.MinValue = 0, .MaxValue = 100}
		mainGrid.Children.Add(plot1)

		' add renderer
		Dim barRenderer = New BarRenderer(series)
		barRenderer.LabelBrush = New SolidBrush(Color.FromArgb(200, 200, 200))
		barRenderer.LabelFontStyle = System.Drawing.FontStyle.Italic
		plot1.SeriesRenderers.Add(barRenderer)

		' add labels renderer
		Dim annotationRenderer = New AnnotationRenderer(annotations)
		plot1.SeriesRenderers.Add(annotationRenderer)

		' create axes
		Dim yAxis = New YAxisRenderer(plot1.YAxis, plot1.XAxis)
		yAxis.PlotLeftSide = True
		yAxis.GridColumn = 0
		yAxis.LabelsSource = plot1
		mainGrid.Children.Add(yAxis)

		Dim xAxis = New XAxisRenderer(plot1.XAxis)
		xAxis.GridRow = 1
		xAxis.GridColumn = 1
		xAxis.LabelsSource = plot1
		xAxis.ShowCoordinates = False
		xAxis.LabelFontStyle = System.Drawing.FontStyle.Underline
		mainGrid.Children.Add(xAxis)

		' styles
		plot1.GridType = GridType.Crossed
		plot1.XAxis.Title = ""
		plot1.YAxis.Title = ""
		plot1.GridColor1 = Color.Black
		plot1.GridColor1 = Color.White
		barChart.BackColor = Color.FromArgb(70, 70, 70)
		barChart.Theme.CommonSeriesFills = GetFills()
		barChart.Theme.AxisStroke = New SolidBrush(Color.White)
		barChart.Theme.AxisLabelsBrush = New SolidBrush(Color.White)
		barChart.Theme.UniformSeriesStroke = New SolidBrush(Color.White)
		barChart.Theme.HighlightStroke = New SolidBrush(Color.FromArgb(70, 70, 70))
		barChart.Theme.HighlightStrokeThickness = 1
		barChart.Theme.PlotBackground = New LinearGradientBrush(Color.Black, Color.White)


	End Sub

	Private Function GetFills() As List(Of Brush)
		Dim fills As New List(Of Brush)()

		fills.Add(New LinearGradientBrush(Color.FromArgb(224, 233, 233), Color.FromArgb(91, 121, 165)))
		fills.Add(New LinearGradientBrush(Color.FromArgb(102, 154, 204), Color.FromArgb(0, 52, 102)))
		fills.Add(New LinearGradientBrush(Color.FromArgb(192, 192, 192), Color.FromArgb(45, 57, 86)))
		fills.Add(New LinearGradientBrush(Color.FromArgb(186, 0, 0), Color.FromArgb(220, 0, 0)))

		Return fills
	End Function


End Class
